<Cabbage>
form caption("Image Sliders") size(420, 160), colour(85, 85, 85) pluginID("def1")
;knob1
image bounds(10, 10, 96, 96), file("knobImage0.png"), identchannel("knob0Ident")
rslider bounds(10, 10, 96, 96), channel("knob0"), range(0, 1, 0, 1, .01), alpha(0), popuptext(0)
label bounds(18, 106, 80, 16), text("Att: 0.00"), identchannel("knob0LabelIdent") 
;knob2
image bounds(110, 10, 96, 96), file("knobImage0.png"), identchannel("knob1Ident")
rslider bounds(110, 10, 96, 96), channel("knob1"), range(0, 1, 0, 1, .01), alpha(0), popuptext(0)
label bounds(118, 106, 80, 16), text("Dec: 0.00"), identchannel("knob1LabelIdent") 
;knob3
image bounds(210, 10, 96, 96), file("knobImage0.png"), identchannel("knob2Ident")
rslider bounds(210, 10, 96, 96), channel("knob2"), range(0, 1, 0, 1, .01), alpha(0), popuptext(0)
label bounds(218, 106, 80, 16), text("Sus: 0.00"), identchannel("knob2LabelIdent") 
;knob4
image bounds(310, 10, 96, 96), file("knobImage0.png"), identchannel("knob3Ident")
rslider bounds(310, 10, 96, 96), channel("knob3"), range(0, 1, 0, 1, .01), alpha(0), popuptext(0)
label bounds(318, 106, 80, 16), text("Rel: 0.00"), identchannel("knob3LabelIdent") 

</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d 
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
sr = 44100
ksmps = 32
nchnls = 2
0dbfs = 1


instr 1
chnset "Att: 0.00", "knob0LabelIdent"
chnset "Dec: 0.00", "knob1LabelIdent"
chnset "Rel: 0.00", "knob2LabelIdent"
chnset "Sus: 0.00", "knob3LabelIdent"
endin

instr 2
kKnob[] init 4
kKnobImage[] init 4
kKnobCounter init 3
SLabel[] init 4
SLabel[0] = "Att: "
SLabel[1] = "Dec: "
SLabel[2] = "Sus: "
SLabel[3] = "Rel: "

	SKnobChannel sprintfk "knob%d", kKnobCounter
	kKnob[kKnobCounter] chnget SKnobChannel
	
	kKnobImage[kKnobCounter] = int(kKnob[kKnobCounter]*30)
	if changed(kKnobImage[kKnobCounter]) == 1 then
		SMessage sprintfk "file(\"knobImage%d.png\")", kKnobImage[kKnobCounter]
		SChannelName sprintfk "knob%dIdent", kKnobCounter
		chnset SMessage, SChannelName
	endif
	
	if changed(kKnob[kKnobCounter]) == 1 then
		SMessage sprintfk "text(\"%s %.2f\")", SLabel[kKnobCounter], kKnob[kKnobCounter]
		SName sprintfk "knob%dIdent", kKnobCounter
		SChannelName sprintfk "knob%dLabelIdent", kKnobCounter
		chnset SMessage, SChannelName	
	endif	

	kKnobCounter = (kKnobCounter > 0 ? kKnobCounter-1 : 3) 

endin

</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...
f0 z
i1 0 1
;starts instrument 2 and runs it for a week
i2 0 [60*60*24*7] 
</CsScore>
</CsoundSynthesizer>
